@ECHO OFF
REM ***********************************************************************
REM * Start of program, determine recursive call level.                   *
REM ***********************************************************************
IF "%1"=="" GOTO START
IF "%1"=="RC2" GOTO HIST2
IF "%1"=="RC3" GOTO HIST3
IF "%1"=="RC4" GOTO HIST4
IF "%1"=="RC5" GOTO HIST5
GOTO ERR00

:START
REM ***********************************************************************
REM * Dump unnecessary variables to save space.                           *
REM ***********************************************************************
SET AVER1=
SET AVER2=
SET APRD=
SET AREV=
SET APLT=
SET AWGM=
SET FAMILY=
SET TSPN=
SET OPRD=
SET OPRT=
SET IDRV=
SET DRV=

REM ***********************************************************************
REM * Provide TEMP directory, if necessary.                               *
REM ***********************************************************************
IF NOT "%TEMP%"=="" GOTO FOUND
SET TEMP=C:\TEMP
GOTO FOUND
:FOUND
IF EXIST %TEMP%\NUL GOTO READY
IF EXIST %TEMP% REN %TEMP% %TEMP%.BAK
MD %TEMP%

:READY
REM ***********************************************************************
REM * First display the currently installed system ...                    *
REM ***********************************************************************
CLS
ECHO **********************************************************************
IF NOT EXIST C:\AVERS.BAT GOTO NOTMODRN
ECHO The currently installed system is:
CALL C:\AVERS
GOTO ENDCUR
:NOTMODRN
IF EXIST C:\AMANDA\RAMANDA.EXE GOTO ANCIENT
ECHO Do not detect any current installation.
GOTO ENDCUR
:ANCIENT
ECHO Current system appears to be:
C:\AMANDA\RAMANDA.EXE /?
GOTO ENDCUR
:ENDCUR
CHOICE /C:CQ Continue, or Quit
IF ERRORLEVEL 2 GOTO FINIS
SET ME=%0
GOTO STRTLOOP

:STRTLOOP
REM ***********************************************************************
REM * Main loop of the "Outer block" code, iterates over all products.    *
REM ***********************************************************************
FOR %%A IN (WG WK WP) DO IF EXIST C:\AMANDA.BAK\%%A\NUL CALL %ME% RC2 %%A
ECHO **********************************************************************
SET ME=
ECHO No further Amanda installations could be detected.
IF EXIST C:\AVERS.BAT C:\AVERS.BAT /Q
GOTO FINIS

:HIST2
REM ***********************************************************************
REM * Recursive level 2.  Iterates over major version numbers.            *
REM ***********************************************************************
rem ECHO . HIST2 WAS PASSED %1 %2
FOR %%B IN (6 5 2 1) DO CALL %ME% RC3 %2 %%B
GOTO FINIS

:HIST3
REM ***********************************************************************
REM * Recursive level 3.  Iterates over all minor version numbers.        *
REM ***********************************************************************
rem ECHO . . HIST3 WAS PASSED %1 %2 %3
SET MINVER=45 30 23 21 20 19 18 17 16 14 12 11 10 02 01 00
IF %APLT%=="BI-NTEL" SET MINVER=45 30 23 21 20 18 17 16 14 12 11 10 02 01 00
FOR %%C IN (%MINVER%) DO CALL %ME% RC4 %2 %3 %%C
GOTO FINIS

:HIST4
REM ***********************************************************************
REM * Recursive level 4.  Checks for, iterates over all Revision levels.  *
REM ***********************************************************************
rem ECHO . . . HIST4 WAS PASSED %1 %2 %3 %4
rem IF EXIST C:\AMANDA.BAK\%2\%3%4\NUL ECHO . . . . HIST4 FOUND %2 %3%4 - NO REV
FOR %%D IN (G F E D C B A) DO IF EXIST C:\AMANDA.BAK\%2\%3%4%%D\NUL CALL %ME% RC5 %2 %3 %4 %%D
IF EXIST C:\AMANDA.BAK\%2\%3%4\NUL CALL %ME% RC5 %2 %3 %4
GOTO FINIS

:HIST5
REM ***********************************************************************
REM * Recursive level 5.  Displays information about an installation.     *
REM ***********************************************************************
SET REV=
IF NOT "%5"=="" SET REV=%5

:MAIN
REM ***********************************************************************
REM * Main block of level 5; calls item procedures.                       *
REM ***********************************************************************
ECHO **********************************************************************
rem ECHO . . . . . HIST5 WAS PASSED %1 %2 %3 %4 %5
SET RADD5=IT1
GOTO PROD
:IT1
SET RADD5=IT2
GOTO ACTION
:IT2
SET RADD5=IT3
GOTO PRIOR
:IT3
SET RADD5=IT4
GOTO RECOV
:IT4
SET RADD5=IT5
GOTO BLDID
:IT5
SET RADD5=IT6
GOTO INSTC
:IT6
SET RADD5=IT7
GOTO UNINST
:IT7
SET RADD5=IT8
GOTO HRDERR
:IT8
SET RADD5=IT9
GOTO DISCARD
:IT9
SET RADD5=IT10
GOTO VIEW
:IT10
GOTO END5

:PROD
REM ***********************************************************************
REM * Detail procedure displays product name.                             *
REM ***********************************************************************
IF "%2"=="WP" GOTO WPLACE
IF "%2"=="WK" GOTO WORK
IF "%2"=="WG" GOTO WGROUP
GOTO ERR01
:WGROUP
ECHO Found installation of Amanda@Work.Group Version %3.%4%REV%
GOTO %RADD5%
:WPLACE
ECHO Found installation of Amanda@Work.Place Version %3.%4%REV%
GOTO %RADD5%
:WORK
ECHO Found installation of Amanda@Work Version %3.%4%REV%
GOTO %RADD5%

:BLDID
REM ***********************************************************************
REM * Detail procedure displays the Build ID of this installation.        *
REM ***********************************************************************
ECHO The BUILD.ID for this installation is:
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\BUILD.ID GOTO GOTID
ECHO     -Unknown-
GOTO %RADD5%
:GOTID
TYPE C:\AMANDA.BAK\%2\%3%4%5\BUILD.ID
GOTO %RADD5%

:ACTION
REM ***********************************************************************
REM * Detail procedure displays installation type.                        *
REM ***********************************************************************
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTION?.BAT GOTO ISTHERE
:ISGONE
ECHO This installation was un-installed.
GOTO %RADD5%
:ISTHERE
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\AVERS.BAT GOTO NOTORIG
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIOND.BAT GOTO NOTORIG
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIONZ.BAT GOTO ISGONE
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIONA.BAT ECHO This installation was an original.
GOTO %RADD5%
:NOTORIG
ECHO This installation was an update/upgrade.
GOTO %RADD5%

:PRIOR
REM ***********************************************************************
REM * Detail procedure displays prior product updated/upgraded.           *
REM ***********************************************************************
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\PRODUCT.BAT GOTO HASPRDID
IF NOT EXIST C:\AMANDA.BAK\%2\%3%4%5\AVERS.BAT GOTO NOHIST
SET AVER1=
SET AVER2=
SET APRD=
SET AREV=
SET APLT=
SET AWGM=
SET TSPN=
CALL C:\AMANDA.BAK\%2\%3%4%5\AVERS.BAT /Q
IF "%APRD%"=="Work" SET APRD=Amanda@Work
IF "%APRD%"=="Work.Place" SET APRD=Amanda@Work.Place
ECHO @SET OPRD=%APRD% %AVER1%.%AVER2% %AREV%> C:\AMANDA.BAK\%2\%3%4%5\PRODUCT.BAT
ECHO @SET OPRT=*>> C:\AMANDA.BAK\%2\%3%4%5\PRODUCT.BAT
:HASPRDID
SET AVER1=
SET AVER2=
SET APRD=
SET AREV=
SET APLT=
SET AWGM=
SET TSPN=
CALL C:\AMANDA.BAK\%2\%3%4%5\PRODUCT
IF NOT "%OPRT%"=="*" GOTO NOTMEM1
ECHO The prior product updated/upgraded was: %OPRD%
SET OPRD=
SET OPRT=
GOTO %RADD5%
:NOTMEM1
ECHO Insufficient environment memory to display updated/upgraded product.
SET OPRD=
SET OPRT=
GOTO %RADD5%
:NOHIST
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIONA.BAT GOTO %RADD5%
IF NOT EXIST C:\AMANDA.BAK\%2\%3%4%5\AMANDA\RAMANDA.EXE GOTO UNKNWN
ECHO Detected this Amanda product:
C:\AMANDA.BAK\%2\%3%4%5\AMANDA\RAMANDA /?
GOTO %RADD5%
:UNKNWN
ECHO The prior product updated/upgraded was: -Unknown-
GOTO %RADD5%

:RECOV
REM ***********************************************************************
REM * Detail procedure displays "un-installability" of this installation. *
REM ***********************************************************************
IF NOT EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTION?.BAT GOTO ONLYHOPE
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIONZ.BAT GOTO NOHOPE
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\AVERS.BAT GOTO HOPE
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIONA.BAT GOTO NOPRIOR
:HOPE
ECHO The files backed up by this installation appear intact; an un-install
ECHO should be possible.
GOTO %RADD5%
:ONLYHOPE
ECHO The files backed up by this installation should be recoverable.
GOTO %RADD5%
:NOPRIOR
ECHO Un-installing this installation will result in a bare machine.
GOTO %RADD5%
:NOHOPE
ECHO Files backed up by this installation have been deleted by the
ECHO DISCARD program; no recovery is possible.
GOTO %RADD5%

:INSTC
REM ***********************************************************************
REM * Detail procedure displays the "installation start events" count.    *
REM ***********************************************************************
IF EXIST C:\AMANDA\GREP.EXE SET FIND1=C:\AMANDA\GREP -ic
IF EXIST C:\DOS\FIND.EXE SET FIND1=FIND /I /C
IF "%FIND1%"=="" GOTO ERR02
SET FND=*
IF NOT "%FND%"=="*" GOTO ERR03
ECHO Number of installation "starts" found for this product is:
TYPE C:\AMANDA.BAK\%2\%3%4%5\SUMLOG | %FIND1% "Installation started at" > %TEMP%\INTCNT.TXT
TYPE %TEMP%\INTCNT.TXT
DEL %TEMP%\INTCNT.TXT > NUL
SET FND=
SET FIND1=
GOTO %RADD5%

:UNINST
REM ***********************************************************************
REM * Detail procedure detects un-install events.                         *
REM ***********************************************************************
IF NOT EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTION?.BAT GOTO %RADD5%
IF EXIST C:\AMANDA\GREP.EXE SET FIND1=C:\AMANDA\GREP -i
IF EXIST C:\DOS\FIND.EXE SET FIND1=FIND /I
IF "%FIND1%"=="" GOTO ERR02
SET FND=*
IF NOT "%FND%"=="*" GOTO ERR03
TYPE C:\AMANDA.BAK\%2\%3%4%5\SUMLOG | %FIND1% "Un-install of" > %TEMP%\TMP1.TXT
SET FND=
SET FIND1=
COPY /Y %TEMP%\TMP1.TXT %TEMP%\TMP2.TXT > NUL
DEL %TEMP%\TMP1.TXT > NUL
IF NOT EXIST %TEMP%\TMP2.TXT GOTO %RADD5%
ECHO One or more Un-install events were recorded for this product.
DEL %TEMP%\TMP2.TXT > NUL
GOTO %RADD5%

:DISCARD
REM ***********************************************************************
REM * Detail procedure detects usage of the DISCARD program.              *
REM ***********************************************************************
IF EXIST C:\AMANDA.BAK\%2\%3%4%5\ACTIONZ.BAT GOTO %RADD5%
IF EXIST C:\AMANDA\GREP.EXE SET FIND1=C:\AMANDA\GREP -i
IF EXIST C:\DOS\FIND.EXE SET FIND1=FIND /I
IF "%FIND1%"=="" GOTO ERR02
SET FND=*
IF NOT "%FND%"=="*" GOTO ERR03
TYPE C:\AMANDA.BAK\%2\%3%4%5\SUMLOG | %FIND1% "DISCARD HAS DELETED" > %TEMP%\TMP1.TXT
SET FND=
COPY /Y %TEMP%\TMP1.TXT %TEMP%\TMP2.TXT > NUL
DEL %TEMP%\TMP1.TXT > NUL
IF NOT EXIST %TEMP%\TMP2.TXT GOTO %RADD5%
ECHO The DISCARD program has been run one or more times on this installation !
DEL %TEMP%\TMP2.TXT > NUL
GOTO %RADD5%

:HRDERR
REM ***********************************************************************
REM * Detail procedure detects possible hardware errors during install.   *
REM ***********************************************************************
IF EXIST C:\AMANDA\GREP.EXE SET FIND1=C:\AMANDA\GREP -i
IF EXIST C:\DOS\FIND.EXE SET FIND1=FIND /I
IF "%FIND1%"=="" GOTO ERR02
SET FND=*
IF NOT "%FND%"=="*" GOTO ERR03
TYPE C:\AMANDA.BAK\%2\%3%4%5\SUMLOG | %FIND1% "Install terminated" > %TEMP%\TMP1.TXT
SET FND=
COPY /Y %TEMP%\TMP1.TXT %TEMP%TMP2.TXT > NUL
DEL %TEMP%\TMP1.TXT > NUL
IF NOT EXIST %TEMP%\TMP2.TXT GOTO %RADD5%
ECHO Compatibility problems were detected during installation of this product.
DEL %TEMP%\TMP2.TXT
GOTO %RADD5%

:VIEW
REM ***********************************************************************
REM * Offers a choice of viewing the installation SUMLOG file.            *
REM ***********************************************************************
IF NOT EXIST C:\AMANDA\LESS.EXE GOTO IFLESS
IF "%LESS%"=="" SET LESS=-iqM
IF "%LESSHELP%"=="" SET LESSHELP=C:\AMANDA\LESS.HLP
CHOICE /C:VC View the SUMLOG file, or Continue ...
IF ERRORLEVEL 2 GOTO %RADD5%
CLS
C:\AMANDA\LESS C:\AMANDA.BAK\%2\%3%4%5\SUMLOG
SET LESS=
SET LESSHELP=
CLS
GOTO MAIN
:IFLESS
IF NOT EXIST A:\LESS.EXE GOTO NOLESS
IF "%LESS%"=="" SET LESS=-iqM
IF "%LESSHELP%"=="" SET LESSHELP=A:\LESS.HLP
CHOICE /C:VC View the SUMLOG file, or Continue ...
IF ERRORLEVEL 2 GOTO %RADD5%
CLS
A:\LESS C:\AMANDA.BAK\%2\%3%4%5\SUMLOG
SET LESS=
SET LESSHELP=
CLS
GOTO MAIN
:NOLESS
CHOICE /C:C LESS Utility not located; can't view the SUMLOG file.  Continue
GOTO %RADD5%

:ERR00
ECHO Usage is: HISTORY         (no parameters)
GOTO FINIS

:ERR01
ECHO ERROR #01 - UNKNOWN PRODUCT CODE FOR THIS INSTALLATION -
GOTO %RADD5%

:ERR02
ECHO ERROR #02 - CAN'T LOCATE 'FIND' OR 'GREP' -
GOTO %RADD5%

:ERR03
ECHO ERROR #03 - INSUFFICIENT ENVIRONMENT MEMORY FOR TEST; NOT PERFORMED -
SET FIND1=
SET FND=
GOTO %RADD5%

:END5
SET REV=
SET RADD5=
SET FIND1=
SET FND=

:FINIS
REM ***********************************************************************
REM * Exit of the entire routine, all returns go through here.            *
REM ***********************************************************************
EXIT
 